/*
    Uiml.Net: a .Net UIML renderer (http://lumumba.luc.ac.be/kris/research/uiml.net)

	 Copyright (C) 2003  Kris Luyten (kris.luyten@luc.ac.be)
	                     Expertise Centre for Digital Media (http://edm.luc.ac.be)
								Limburgs Universitair Centrum

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public License
	as published by the Free Software Foundation; either version 2.1
	of	the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

namespace Uiml{

	using System;
	using System.Collections; 

	///<summary>
	///</summary>
	public class TemplateRepository{
		private static TemplateRepository instance = null;
		private Hashtable templates;
		
		private TemplateRepository()
		{	
			templates = new Hashtable();
		}

		public static TemplateRepository Instance
		{
			get
			{
				if(instance==null)
					instance = new TemplateRepository();
				return instance;
			}
		}

		public void Register(Template t)
		{
			try{
				templates.Add(t.Identifier, t);
			}catch(ArgumentNullException ane){
				Console.WriteLine("Template with no identifier!");
			}catch(ArgumentException ae){
				Console.WriteLine("Template {0} is already in templates repository", t.Identifier);
			}		}


		

		public Template Query(string id)
		{
			return (Template)templates[id];
		}
		
		
	}
}
